#ifndef ENTITY_H
#define ENTITY_H

using coordinate = unsigned int;

/// Interface representing entity which can be placed on the map
class Entity
{
protected:
    coordinate pos_x, pos_y;

public:
    Entity(coordinate _x = 0, coordinate _y = 0);

    virtual ~Entity() = 0;

    /// Get current Entity position
    void position(coordinate &x, coordinate &y) const noexcept;

    /// Set Entity position explicitly
    void setPosition(coordinate x, coordinate y);

    /// Get current x of the Entity position
    coordinate x() const noexcept;

    /// Get current y of the Entity position
    coordinate y() const noexcept;
};

#endif // ENTITY_H
